/***********************************************************************************
File Name: addressContentTemp32.cpp
Find the content and the address for each memory variable in the char array
Method: Embedding an in-line assembly language module into a C program


A.Find the contents for each element of an 16-bit array
B.Find the addresses for each element of an 16-bit array
C.Find out the number of bytes of each element in an 32-bit array
D.Find out the number of bytes of the address of each element in an 32-bit array

sizeof() to find the number of bytes
printf() is used to display information on the console
system("pause") is used to hold the console
***********************************************************************************/
#include <stdio.h>
#include<iostream>
int main()
{
	/*An 16-bit one dimensional sc8_arr[5] array declaration and initialization.
	Pointers of ivPtr0,ivPtr1,etc will be used to store the address of each element of the array
	A 32-bit array md[4] will be used to store each of the pointers
	A 32-bit array madd[4] is ued to store the address of each element of the array
	*/

	int const size = 4;
	short int i32[size] = {0x8000000,0x0000ffff,-660000,6600000 }; //32bit array
	short *ivPtr0, *ivPtr1, *ivPtr2, *ivPtr3;
	int md[size], madd[size];
	int i;

	ivPtr0 = &i32[0];
	ivPtr1 = &i32[1];
	ivPtr2 = &i32[2];
	ivPtr3 = &i32[3];


	//Display the address of each element in an array i32[4]
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	printf("--------The value of each element of 16-bit array-------\n");
	for (i = 0; i < 4; i++) {
		printf("The value of element %d in an array is 0x%X (HEX), %d(DECIMAL), %c(CHARACTER)\n",
			i, i32[i], i32[i], i32[i]);
	}

	;



	//Display address in hexadecimal for each element of char array
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	printf("-----------------The value of each element of 16-bit array-----------------\n");
	for (i = 0; i < 4; i++)
		printf("The memory address of element %d in an array is 0x%X (hexidecimal)\n", i, ivPtr0 + i);

	//Find the total numbers in byte of array sh16 arr[5]
	printf("====The size information in bytes of an 16-bit array====\n");
	printf("The total numbers in bytes of an 16-bit array with 4 elements is %d bytes\n"),
		sizeof(i32);

	// Find the number of byte(s) of each element of array
	for (i = 0; i < 4; i++)
	{
		md[i] = sizeof(i32[i]);
		madd[i] = sizeof(ivPtr0 + i);
		printf("=====\n");
		printf("The size of element %d is %d bytes\n", i, md[i]);
		printf("The size of the address of the element %d is %d bytes\n ", i, madd[i]);
	}

	system("pause");
	return 0;
}

