/***********************************************************************************
File Name: addressContent.cpp
Find the content and the address for each memory variable in the char array
Method: Embedding an in-line assembly language module into a C program


A.Find the contents for each element of an 8-bit array
B.Find the addresses for each element of an 8-bit array
C.Find out the number of bytes of each element in an 8-bit array
D.Find out the number of bytes of the address of each element in an 8-bit array

sizeof() to find the number of bytes
printf() is used to display information on the console
system("pause") is used to hold the console
***********************************************************************************/
#include <stdio.h>
#include<iostream>
int main()
{
	/*An 8-bit one dimensional sc8_arr[5] array declaration and initialization.
	Pointers of scPtr0,scPtr1,etc will be used to store the address of each element of the array
	A 32-bit array md[5] will be used to store each of the pointers
	A 32-bit array madd[5] is ued to store the address of each element of the array
	A 8-bit array var[5] is used to store the retrieved value by indirect memory addressing mode*/

	char sc8_arr[5] = { 0x41,0x42,0x59,0x79,0x7A };
	char *scPtr0, *scPtr1, *scPtr2, *scPtr3, *scPtr4;
	int md[5], madd[5];
	int i;	//used as index

	//address for each element in an array sc8_arr[5]
	scPtr0 = &sc8_arr[0];
	scPtr1 = &sc8_arr[1];
	scPtr2 = &sc8_arr[2];
	scPtr3 = &sc8_arr[3];
	scPtr4 = &sc8_arr[4];

	//Display Hex Value, Decimal Value, and Char Value for each element of char array
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	printf("-----------------The value of each element of 8-bit array-----------------\n");

	for (i = 0; i < 5; i++) {
		printf("The value of element %d in an array is 0x%X (HEX), %d(DECIMAL), %c(CHARACTER)\n",
			i, sc8_arr[i], sc8_arr[i], sc8_arr[i]);
	}



	//Display address in hexadecimal for each element of char array
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	printf("-----------------The value of each element of 8-bit array-----------------\n");
	for (i = 0; i < 5; i++)
		printf("The memory address of element %d in an array is 0x%X (hexidecimal)\n", i, scPtr0 + i);

	//Find the total numbers in byte of array sc8 arr[5]
	printf("====The size information in bytes of an 8-bit array====\n");
	printf("The total numbers in bytes of an 8-bit array with 5 elements is %d bytes\n"),
		sizeof(sc8_arr);

	// Find the number of byte(s) of each element of array
	for (i = 0; i < 5; i++)
	{
		md[i] = sizeof(sc8_arr[i]);
		madd[i] = sizeof(scPtr0 + i);
		printf("=====\n");
		printf("The size of element %d is %d bytes\n", i, md[i]);
		printf("The size of the address of the element %d is %d bytes\n "), i, madd[i];
	}
	system("pause");
	return 0;
}

