/***********************************************************************************
File Name: addressContentTemp16.cpp
Find the content and the address for each memory variable in the char array
Method: Embedding an in-line assembly language module into a C program


A.Find the contents for each element of an 16-bit array
B.Find the addresses for each element of an 16-bit array
C.Find out the number of bytes of each element in an 16-bit array
D.Find out the number of bytes of the address of each element in an 16-bit array

sizeof() to find the number of bytes
printf() is used to display information on the console
system("pause") is used to hold the console
***********************************************************************************/
#include <stdio.h>
#include<iostream>
int main()
{
	/*An 16-bit one dimensional sc8_arr[5] array declaration and initialization.
	Pointers of svPtr0,svPtr1,etc will be used to store the address of each element of the array
	A 32-bit array md[4] will be used to store each of the pointers
	A 32-bit array madd[4] is ued to store the address of each element of the array
	*/

	int const size = 4;
	short int sh16_arr[size] = { -1,-3,1000,2000 }; //16bit array
	short *svPtr0, *svPtr1, *svPtr2, *svPtr3;
	int md[size], madd[size];
	int i;

	svPtr0 = &sh16_arr[0];
	svPtr1 = &sh16_arr[1];
	svPtr2 = &sh16_arr[2];
	svPtr3 = &sh16_arr[3];


	//Display the address of each element in an array sh16_arr[4]
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	printf("--------The value of each element of 16-bit array-------\n");
	for (i = 0; i < 4; i++) {
		printf("The value of element %d in an array is 0x%X (HEX), %d(DECIMAL), %c(CHARACTER)\n",
			i, sh16_arr[i], sh16_arr[i], sh16_arr[i]);
	}

	;



	//Display address in hexadecimal for each element of char array
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n");
	printf("-----------------The value of each element of 16-bit array-----------------\n");
	for (i = 0; i < 4; i++)
		printf("The memory address of element %d in an array is 0x%X (hexidecimal)\n", i, svPtr0 + i);

	//Find the total numbers in byte of array sh16 arr[5]
	printf("====The size information in bytes of an 16-bit array====\n");
	printf("The total numbers in bytes of an 16-bit array with 4 elements is %d bytes\n"),
		sizeof(sh16_arr);

	// Find the number of byte(s) of each element of array
	for (i = 0; i < 4; i++)
	{
		md[i] = sizeof(sh16_arr[i]);
		madd[i] = sizeof(svPtr0 + i);
		printf("=====\n");
		printf("The size of element %d is %d bytes\n", i, md[i]);
		printf("The size of the address of the element %d is %d bytes\n ",i,madd[i]);
	}
	
	system("pause");
	return 0;
}

